(* int.fun - built-in predicates for integers.				*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)


functor LpInt
    (structure CompTable : COMP_TABLE
     structure IU : IU

     val int_module : CompTable.module

     sharing type IU.compiled_pred = CompTable.compiled_pred) =
struct

local
    open IU;
in

    fun getInt x =
	need "arguments to int comparison functions must be rigid."
	(theInt x);

    val int_pred = bin_pred getInt;

    val int_bi = [("<", int_pred (op <)),
		  (">", int_pred (op >)),
		  (">=", int_pred (op >=)),
		  ("=<", int_pred (op <=))];

    val _ = map (CompTable.make int_module) int_bi;


end (* local *)
end; (* functor LpInt *)
