(* list.fun - lProlog lists.						*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)


functor LpList
    (structure LTerm : LTERM
     structure Module : MODULE

     val list_mod : Module.module

     sharing type Module.const = LTerm.Const.const
     sharing type Module.tp_const = LTerm.Type.Const.const)
	 : LP_LIST =
struct

    type lterm = LTerm.lterm;
    type tp = LTerm.Type.tp;

    val SOME (Module.Con nil_const) = Module.sign_lookup [list_mod] "nil";
    val SOME (Module.Con cons_const) = Module.sign_lookup [list_mod] "::";
    val SOME (Module.TypeCon list_const) = Module.sign_lookup [list_mod]"list";

    val list = LTerm.Type.construct_const list_const

    fun lp_nil tp =
	LTerm.construct_const
	(nil_const, LTerm.Type.construct_application (list, tp));

    val make_type =
	 fn tp =>
	 LTerm.Type.construct_arrow
	 (tp,
	  LTerm.Type.construct_arrow
	  (LTerm.Type.construct_application (list, tp),
	   LTerm.Type.construct_application (list, tp)));

    fun lp_cons (tp, l, ls) =
	 LTerm.construct_application
	 (LTerm.construct_application
	  (LTerm.construct_const (cons_const, make_type tp), l),
	  ls);

end;
