(* real.fun - built-in predicates on reals.				*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

functor LpReal
    (structure CompTable : COMP_TABLE
     structure IU : IU

     val real_module : CompTable.module

     sharing type IU.compiled_pred = CompTable.compiled_pred) =
struct

local
    open IU
in

    fun getReal x =
	need "arguments to real number comparison predicates must be rigid."
	(theReal x);

    val real_pred = bin_pred getReal;
	
    val real_bi = [("r=<", real_pred (op <=)),
		   ("r>=", real_pred (op >=)),
		   ("r<", real_pred (op <)),
		   ("r>", real_pred (op >))];

    val _ = map (CompTable.make real_module) real_bi;
	
end (* local *)
end; (* functor LpReal *)
