(* trace.fun - goal tracing.						*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)


functor Trace
    (structure IU : IU
     structure CompTable : COMP_TABLE
     structure Interpreter : INTERPRETER

     val trace_mod : CompTable.module

     sharing type IU.compiled_pred = CompTable.compiled_pred
     sharing type IU.constraint = Interpreter.constraint
     sharing type Interpreter.i_record = IU.i_record
     sharing type Interpreter.lterm = IU.lterm) =
struct    
local
    open IU
in

    fun spy ((_, [spy_goal, M]), record as (IR {traced, ...}), con, sc) =
	Interpreter.solve (M, add_traced (spy_goal :: traced, record), con, sc)
      | spy _ =  ();

    val _ = CompTable.make trace_mod ("spy", IU.GFunc spy);

end (* local open IU *)
end;
