(* kind.fun - kinds							*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

functor Kind (structure Formatter : FORMATTER) : KIND =
struct

    datatype kind =
	Type
      | Karrow of kind;

    val equal = Lib.Misc.equal;

local
    open Formatter
in
    type format = format;

    fun makeformat_kind kind =
	let
	    fun mfk Type = [String "type"]
	      | mfk (Karrow k) =
		(String "type ->") :: Break :: (mfk k)
	in
	    HOVbox (mfk kind)
	end;
end (* local open Formatter *)
end; (* functor Kind *)