signature DEBUG =
    sig
	type lterm;
	type tp;

	val t2s : lterm -> string;
    end;
    
functor Debug (structure LTerm : LTERM_SIMPLE) : DEBUG=
struct

local
    open LTerm
in

    type lterm = lterm;
    type tp = LTerm.Type.tp;

    fun lterm2string (Lam (_, M)) = "Lam " ^ (lterm2string M)
      | lterm2string (App (M, N)) =
	"App (" ^ (lterm2string M) ^ " ," ^ (lterm2string N) ^ ")"
      | lterm2string (Index i) = "Index " ^ (Lib.Convert.itoa i)
      | lterm2string (ConstUvar (cuv, _)) =
	(case (LTerm.Const.name_hint cuv) of
	     NONE => "noname"
	   | SOME name  => name)
      | lterm2string (Evar (ev, ref (SOME M))) =
	((case (LTerm.Evar.name_hint ev) of
	      NONE => "noname-evar"
	    | SOME name => name) ^
	 ".{" ^ (lterm2string M) ^ "}")
      | lterm2string (Evar (ev, _)) =
	(case (LTerm.Evar.name_hint ev) of
	     NONE => "noname-evar"
	   | SOME name => name)

    val t2s = lterm2string

end
end;


