(* print.sig - printing of terms, types, substitutions, and		*)
(* constraints.								*)

(* Copyright (c) 1991,1994,1995 by Carnegie Mellon University		*)
(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Authors:								*)
(*	Frank Pfenning <fp@cs.cmu.edu>					*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

signature PRINT =
    sig
	type lterm;
	type tp;
	type kind;
	type constraint;
	type name_env;
	type format;

	val makeformat_kind : kind -> format;
	val makeformat_type : name_env -> tp -> format;
	val makeformat_lterm : name_env -> lterm -> format;
	    
	val makestring_type : name_env -> tp -> string;
	val makestring_lterm : name_env -> lterm -> string;
	val makestring_constraint : name_env -> constraint -> string;
	val makestring_substitution : name_env -> lterm list -> string;

	(* Utilities for debugging *) 
	val debug : lterm -> string;
	val debug_type : tp -> string;
	val senv : name_env;

    end; (* signature PRINT *)
