(* PTERM.SIG - Printing term - datatype for printing			*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

signature PTERM =
    sig

	include FIXITY;

	datatype ('a, 'b) pterm =
	    Lam of 'a * ('a, 'b) pterm
	  | App of ('a, 'b) pterm * ('a, 'b) pterm
	  | Oper of 'a * (int * associativity) *
	    ('a, 'b) pterm * ('a, 'b) pterm
	  | Evar of 'b
	  | Uvar of 'a
	  | Const of 'a;
    end; (* signature PTERM *)
