(* trail.fun - trailing, and undo-ing.					*)

(* Copyright (c) 1991,1994,1995 by Carnegie Mellon University		*)
(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Authors:								*)
(*	Frank Pfenning <fp@cs.cmu.edu>					*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

functor Trail ()
    : TRAIL =
struct

local
    datatype trail =
	consTrail of (unit -> unit) * (trail ref)
      | nilTrail;

	val global_trail = ref (ref nilTrail)
in
    
    fun unwind_trail shorter_trail longer_trail =
	if longer_trail = shorter_trail then
	    global_trail := shorter_trail
	else
	    (case !longer_trail of
		 consTrail (func, rest_trail) =>
		     (func ();
		      unwind_trail shorter_trail rest_trail)
	       | _ =>
		     raise Basic.InternalError "unwind_trail: internal error.");

    fun trail func = 
	let
	    val old_trail = !global_trail
	in
	    (func ();
	     unwind_trail old_trail (!global_trail))
	end;

    fun undo undo =
	global_trail := ref (consTrail (undo, !global_trail));

end (* local *)
end; (* functor Trail *)
