(* uutils.sig - unification utilities.					*)

(* Copyright (c) 1991,1994,1995 by Carnegie Mellon University		*)
(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Authors:								*)
(*	Frank Pfenning <fp@cs.cmu.edu>					*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

signature UUTILS =
sig

    type lterm;
    type dpair;

    exception NonUnifiable;

    val is_flex : lterm -> bool;

    val abst_over_uvar : lterm * lterm -> lterm;
    val abst_over_uvar_raise : lterm * lterm -> lterm;

    val quick_eoc : (lterm * lterm list) * lterm -> bool;
    val extended_occurs_check :
	(lterm * lterm list) * lterm * dpair list -> lterm * dpair list;

end; (* signature UUTILS *)
