(* var.fun - variables							*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

functor Var
    (structure Const : CONST

     type tp)
	 : VAR =
struct

    type uvar = Const.const;
    type tp = tp;
    type var = 	
	{stamp : int,			(* time stamp *)
	 uvars : uvar list,		(* may depend upon *)
	 name : string option,		(* name	*)
	 id : int,			(* identifier stamp *)
	 tp : tp};			(* type *)

    (********************* Operations on vars **********************)

    fun equal ({id = i1, ...} : var) ({id = i2, ...} : var) = i1 = i2;

    val type_of : var -> tp = #tp;

    val age_of : var -> int = #stamp;
	
    val name_hint : var -> string option = #name;
	
    val uvars : var -> uvar list = #uvars;

    local
	val id_counter = ref 0;
    in
	fun new_var (tp, name_op, uvars) =
	    {tp = tp,
	     name = name_op,
	     id = Lib.Misc.pre_inc id_counter,
	     stamp = Const.stamp (),
	     uvars = uvars};

	fun make_var (tp, stamp, name_opt, uvars) =
	    {tp = tp,
	     name = name_opt,
	     id = Lib.Misc.pre_inc id_counter,
	     stamp = stamp,
	     uvars = uvars};
    end (* local val id_counter ... *)

    fun revsublist_upto (test, l) =
	let
	    fun se (initseg, nil) = (initseg, nil)
	      | se (initseg, x :: rest) =
		if test x then
		    (x :: initseg, rest)
		else
		    se (x :: initseg, rest)
	in
	    se (nil, l)
	end

end; (* functor Var *)
    
