(* var.sig - variables							*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

signature VAR =
    sig

	type uvar;
	type var;
	type tp;

	(* Operations on evars *)
	val equal : var -> var -> bool;
	val type_of : var -> tp;
	val age_of : var -> int;
	val new_var : tp * string option * uvar list -> var;
	val make_var : tp * int * string option * uvar list -> var;
	val name_hint : var -> string option;
	val uvars : var -> uvar list;

end; (* signature VAR *)
