(* error_print.sig - signature for the structure which makes errors	*)
(* messages out of errors.						*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Authors:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)


signature ERROR_PRINT =
    sig

	type error;			(* The type of errors  *)

	(* Raised by error_to_string (and consequently handle_errors	*)
	(* and error_print) when an error which an improper matching of *)
	(* format decls to objects is encountered.			*)
	exception BadFormat of string;

	(* Makes a printable error message out of an error.		*)
	val error_to_string : error -> string;

	(* Uses error_to_string and Error.handle_errors to print and	*)
	(* delete all waiting errors.					*)
	val handle_errors : unit -> unit;

	val error_print : error -> unit; 

end; (* signature ERROR_PRINT *)
