(* logicals.sig - Logical constants					*)

(* Copyright (c) 1991,1994,1995 by Carnegie Mellon University		*)
(* Copyright (c) 1994,1995 by AT&T Bell Laboratories			*)
(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Authors:								*)
(*	Amy Felty <felty@bell-labs.com>					*)
(*	Frank Pfenning <fp@cs.cmu.edu>					*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

signature LOGICALS =
    sig

	type const;
	type tp;

	val pred_type	: tp;
	val ttrue	: const;
	val comma	: const;
	val ampersand	: const;
	val semicolon	: const;
	val arrow	: const;
	val backarrow	: const;
	val pi		: const;
	val sigma	: const;

	val truth	: const;
	val conjunction	: const;
	val disjunction	: const;
	val implication	: const;
	val uquant	: const;
	val equant	: const;

	val is_truth		: const -> bool;
	val is_conjunction	: const -> bool;
	val is_disjunction	: const -> bool;
	val is_implication	: const -> bool;
	val is_uquant		: const -> bool;
	val is_equant		: const -> bool;

	val std_order	: const -> 'a * 'a -> 'a * 'a;

    end  (* signature LOGICALS *)
