(* query.sig - top level interface to the query engine.			*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

signature QUERY =
    sig

	type module;			(* The type of modules *)
	type tp;			(* The type of lProlog types *)
	type sterm;			(* simple terms - built by Absyn *)
	type lterm;			(* lambda terms *)
	type const;			(* constants *)
	type parse_stream;		(* input stream *)
	    
	    
	(* query takes a module against which to query and a raw term and
	 * executes the query. The result is not the result of the query,
	 * rather it is whether or not the query terminated without error. *)
	val query : module -> (tp * string) list * (tp * string) list * sterm
	    -> Basic.result;

	(* interactive_query starts an interactive query loop. Again the
	 * result indicates whether or not the query loop terminated without
	 * error. *)
	val interactive_query : parse_stream -> module -> Basic.result;

end  (* signature QUERY *)

