(* switch.sig - Registry for user setable swicthes.			*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)


signature SWITCH =
    sig
	type switch = string;

	val set : switch -> string -> unit;
	val show : switch -> string;
	val exists : switch -> bool;

	(* The second argument of make consists of two functions: one
	 * which takes a switch_value and updates the value of the
	 * switch and one which returns a printable form of the switch. *)
	val make : switch -> ((string -> unit) * (unit -> string))
	    -> unit;
	  
	(* and app over all switches. *)
	val show_all : (switch * string -> unit) -> unit;

	val makestring_switch : switch * string -> string;

	val explode : string -> string list;
	val implode : string list -> string;

	(* make_on_off make a boolean switch which sets and reads from the
	 * bool ref argument. *)
	val make_on_off : bool ref -> ((string -> unit) * (unit -> string));

    end; (* signature SWITCH *)
