(* terminal_io.fun - input and output to the standard out, error, and	*)
(* in.									*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

functor TerminalIO () : TERMINAL_IO =
    struct

	val std_out = ref Lib.IO.std_out;
	val std_err = ref Lib.IO.std_err;
	val std_in = ref Lib.IO.std_in;

	fun print str =
	    Lib.IO.output (!std_out, str);

	fun message str =
	    print (str ^ "\n");
(*
	fun wrap string_list =
	    let
		fun reverse_strings [] out = out
		  | reverse_strings (l::ls) out =
		    reverse_strings ls (l ^ "\n" ^ out)

		fun wrap_strings (l::ls) current out =
		    if String.size (current ^ l) < 80 then
			wrap_strings ls (current ^ l) out
		    else
			wrap_strings ls l (current::out)
		  | wrap_strings [] current out =  
		    reverse_strings (current::out) "";
	    in
		wrap_strings string_list "" []
	    end;
*)
	fun print_error str =
	    (Lib.IO.output (!std_err, str ^ "\n");
	     Lib.IO.flush_out (! std_err))
    
    end; (* signature TERMINAL_IO *)
