(* lexer_interface.sig - Interface to the ml-lexer generated lexer	*)

(* Copyright (c) 1991,1994,1995 by Carnegie Mellon University		*)
(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Authors:								*)
(*	Frank Pfenning <fp@cs.cmu.edu>					*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

signature LEXER_INTERFACE =
    sig

	type pos = int;
	type region;
	type location;
	type counter;

	datatype lexarg =
	    LA of string * counter;

	val empty_pos : pos;

	val new_counter : unit -> counter;
	val init_counter : counter -> unit;
	    
	val next_line : counter -> pos -> unit;
	val last_newline : counter -> pos;

	val make_region : counter -> pos * pos -> region;
	val makestring_region : region -> string;

	val make_location : counter -> string -> (pos * pos) -> location;
	val makestring_location : location -> string;
	val merge_locations : location * location -> location;

end  (* signature LEXER_INTERFACE *)

signature LOCATION = LEXER_INTERFACE;
