
functor LPLrValsFun
	     (structure Token : TOKEN
	      structure Module : MODULE
	      structure Error : ERROR
	      structure LexerInterface : LEXER_INTERFACE
	      structure ParserInterface : PARSER_INTERFACE
	      structure Absyn : ABSYN

	      val pervasive_mods : Module.module list ref
	      datatype parserarg =
		  A of {name : string, counter : LexerInterface.counter}

	      sharing type Absyn.akind = ParserInterface.akind
	      sharing type Absyn.atype = ParserInterface.atype
	      sharing type Absyn.aterm = ParserInterface.aterm
	      sharing type LexerInterface.location = Error.location =
		  ParserInterface.location = Absyn.location
	      sharing type Absyn.const = Module.const
	      sharing type Module.tp_const = Absyn.tp_const
	      sharing type Absyn.tp = Module.tp) : LP_LRVALS = 
struct
structure ParserData=
struct
structure Header = 
struct
(* lp.grm - ml-yacc grammar file for Terzo lambdaProlog			*)

(* Copyright (c) 1991,1994,1995 by Carnegie Mellon University		*)
(* Copyright (c) 1994,1995 by AT&T Bell Laboratories			*)
(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Authors:								*)
(*	Amy Felty <felty@bell-labs.com>					*)
(*	Elsa Gunter <elsa@research.att.com>				*)
(*	Frank Pfenning <fp@cs.cmu.edu>					*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)


structure PI = ParserInterface;
open Absyn PI;

fun loc (A {counter, name}) lrpos =
    LexerInterface.make_location counter name lrpos;

fun error (location, err) =
    Error.fatal_error (Error.Location (location, err));

fun check (location, i) =
    if i < 0 orelse i > 9 then
	Error.fatal_error
	(Error.Location
	 (location,
	  Error.Illegal ("fixity precedence must be between 0 and 9.", [])))
    else
	i;


end
structure LrTable = Token.LrTable
structure Token = Token
local open LrTable in 
val table=let val actionRows =
"\
\\001\000\002\000\000\000\000\000\
\\001\000\003\000\039\000\006\000\038\000\010\000\037\000\013\000\036\000\
\\014\000\035\000\015\000\034\000\016\000\033\000\017\000\032\000\
\\018\000\031\000\019\000\030\000\025\000\029\000\026\000\028\000\
\\027\000\027\000\028\000\026\000\029\000\025\000\030\000\024\000\
\\031\000\023\000\032\000\022\000\033\000\021\000\034\000\020\000\
\\035\000\019\000\036\000\018\000\037\000\017\000\038\000\016\000\
\\039\000\015\000\040\000\014\000\041\000\013\000\042\000\012\000\000\000\
\\001\000\003\000\039\000\006\000\038\000\010\000\037\000\025\000\029\000\
\\026\000\028\000\027\000\027\000\028\000\026\000\029\000\025\000\
\\030\000\024\000\000\000\
\\001\000\003\000\079\000\020\000\078\000\021\000\077\000\022\000\076\000\
\\023\000\075\000\024\000\074\000\025\000\057\000\026\000\073\000\
\\027\000\056\000\000\000\
\\001\000\004\000\100\000\000\000\
\\001\000\004\000\110\000\007\000\102\000\000\000\
\\001\000\016\000\095\000\000\000\
\\001\000\025\000\046\000\026\000\045\000\000\000\
\\001\000\025\000\049\000\000\000\
\\001\000\025\000\057\000\027\000\056\000\000\000\
\\001\000\028\000\090\000\000\000\
\\001\000\028\000\092\000\000\000\
\\001\000\028\000\093\000\000\000\
\\001\000\030\000\053\000\000\000\
\\113\000\000\000\
\\114\000\000\000\
\\115\000\000\000\
\\116\000\000\000\
\\117\000\000\000\
\\118\000\025\000\047\000\000\000\
\\119\000\000\000\
\\120\000\025\000\048\000\000\000\
\\121\000\000\000\
\\122\000\000\000\
\\123\000\003\000\039\000\006\000\038\000\010\000\037\000\025\000\029\000\
\\026\000\028\000\027\000\027\000\028\000\026\000\029\000\025\000\
\\030\000\024\000\000\000\
\\124\000\025\000\046\000\026\000\045\000\000\000\
\\125\000\000\000\
\\126\000\000\000\
\\127\000\000\000\
\\128\000\000\000\
\\129\000\000\000\
\\130\000\000\000\
\\131\000\000\000\
\\132\000\025\000\057\000\027\000\056\000\028\000\086\000\030\000\085\000\000\000\
\\133\000\000\000\
\\134\000\006\000\089\000\000\000\
\\135\000\000\000\
\\136\000\000\000\
\\137\000\000\000\
\\138\000\000\000\
\\139\000\000\000\
\\140\000\000\000\
\\141\000\006\000\088\000\000\000\
\\142\000\000\000\
\\143\000\000\000\
\\144\000\000\000\
\\145\000\007\000\102\000\000\000\
\\146\000\007\000\102\000\000\000\
\\147\000\000\000\
\\148\000\000\000\
\\149\000\000\000\
\\150\000\000\000\
\\151\000\000\000\
\\152\000\000\000\
\\153\000\003\000\039\000\006\000\038\000\010\000\037\000\025\000\029\000\
\\026\000\028\000\027\000\027\000\028\000\026\000\029\000\025\000\
\\030\000\024\000\000\000\
\\154\000\009\000\042\000\000\000\
\\155\000\007\000\102\000\000\000\
\\156\000\000\000\
\\157\000\000\000\
\\158\000\000\000\
\\159\000\000\000\
\\160\000\000\000\
\\161\000\000\000\
\\162\000\000\000\
\\163\000\004\000\099\000\008\000\041\000\009\000\040\000\000\000\
\\163\000\008\000\041\000\009\000\040\000\000\000\
\\164\000\000\000\
\\165\000\000\000\
\\166\000\000\000\
\\167\000\000\000\
\\168\000\000\000\
\\169\000\007\000\102\000\000\000\
\\170\000\000\000\
\\171\000\000\000\
\\172\000\006\000\091\000\000\000\
\\173\000\000\000\
\\174\000\007\000\102\000\000\000\
\\175\000\003\000\079\000\020\000\078\000\021\000\077\000\022\000\076\000\
\\023\000\075\000\024\000\074\000\025\000\057\000\026\000\073\000\
\\027\000\056\000\000\000\
\\176\000\000\000\
\\177\000\000\000\
\\178\000\000\000\
\\179\000\000\000\
\\180\000\000\000\
\\181\000\000\000\
\\182\000\000\000\
\\183\000\000\000\
\\184\000\000\000\
\\185\000\000\000\
\\186\000\007\000\108\000\000\000\
\\187\000\000\000\
\"
val actionRowNumbers =
"\001\000\065\000\055\000\054\000\
\\045\000\044\000\050\000\016\000\
\\015\000\014\000\029\000\007\000\
\\027\000\026\000\019\000\021\000\
\\008\000\025\000\013\000\009\000\
\\009\000\009\000\062\000\061\000\
\\060\000\066\000\070\000\069\000\
\\009\000\009\000\009\000\009\000\
\\007\000\007\000\007\000\063\000\
\\059\000\002\000\003\000\002\000\
\\003\000\057\000\028\000\040\000\
\\041\000\018\000\020\000\033\000\
\\024\000\042\000\017\000\035\000\
\\010\000\074\000\072\000\073\000\
\\011\000\012\000\006\000\006\000\
\\003\000\003\000\039\000\038\000\
\\037\000\064\000\004\000\078\000\
\\077\000\071\000\080\000\081\000\
\\087\000\086\000\084\000\085\000\
\\083\000\003\000\067\000\056\000\
\\031\000\022\000\033\000\032\000\
\\030\000\023\000\007\000\013\000\
\\052\000\009\000\051\000\053\000\
\\049\000\088\000\048\000\047\000\
\\046\000\068\000\058\000\079\000\
\\003\000\005\000\034\000\043\000\
\\036\000\075\000\006\000\076\000\
\\082\000\089\000\000\000"
val gotoT =
"\
\\001\000\110\000\002\000\009\000\003\000\008\000\004\000\007\000\
\\010\000\006\000\011\000\005\000\012\000\004\000\013\000\003\000\
\\014\000\002\000\017\000\001\000\000\000\
\\000\000\
\\000\000\
\\014\000\041\000\017\000\001\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\005\000\042\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\005\000\049\000\006\000\048\000\000\000\
\\009\000\050\000\000\000\
\\015\000\053\000\016\000\052\000\000\000\
\\015\000\053\000\016\000\056\000\000\000\
\\015\000\053\000\016\000\057\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\015\000\053\000\016\000\058\000\000\000\
\\015\000\053\000\016\000\059\000\000\000\
\\015\000\053\000\016\000\060\000\000\000\
\\015\000\053\000\016\000\061\000\000\000\
\\005\000\049\000\006\000\062\000\000\000\
\\005\000\049\000\006\000\063\000\000\000\
\\005\000\064\000\000\000\
\\000\000\
\\000\000\
\\012\000\066\000\013\000\003\000\014\000\002\000\017\000\065\000\000\000\
\\015\000\070\000\019\000\069\000\020\000\068\000\021\000\067\000\000\000\
\\012\000\078\000\013\000\003\000\014\000\002\000\017\000\001\000\000\000\
\\015\000\070\000\019\000\079\000\020\000\068\000\021\000\067\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\007\000\082\000\008\000\081\000\015\000\080\000\000\000\
\\012\000\085\000\013\000\003\000\014\000\002\000\017\000\001\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\022\000\092\000\000\000\
\\022\000\094\000\000\000\
\\015\000\070\000\019\000\095\000\020\000\068\000\021\000\067\000\000\000\
\\015\000\070\000\019\000\096\000\020\000\068\000\021\000\067\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\015\000\070\000\021\000\099\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\015\000\070\000\019\000\101\000\020\000\068\000\021\000\067\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\007\000\082\000\008\000\102\000\015\000\080\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\005\000\049\000\006\000\103\000\000\000\
\\009\000\104\000\000\000\
\\000\000\
\\015\000\053\000\016\000\105\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\015\000\070\000\019\000\107\000\020\000\068\000\021\000\067\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\022\000\109\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\"
val numstates = 111
val numrules = 75
val s = ref "" and index = ref 0
val string_to_int = fn () => 
let val i = !index
in index := i+2; Char.ord(String.sub(!s,i)) + Char.ord(String.sub(!s,i+1)) * 256
end
val string_to_list = fn s' =>
    let val len = String.size s'
        fun f () =
           if !index < len then string_to_int() :: f()
           else nil
   in index := 0; s := s'; f ()
   end
val string_to_pairlist = fn (conv_key,conv_entry) =>
     let fun f () =
         case string_to_int()
         of 0 => EMPTY
          | n => PAIR(conv_key (n-1),conv_entry (string_to_int()),f())
     in f
     end
val string_to_pairlist_default = fn (conv_key,conv_entry) =>
    let val conv_row = string_to_pairlist(conv_key,conv_entry)
    in fn () =>
       let val default = conv_entry(string_to_int())
           val row = conv_row()
       in (row,default)
       end
   end
val string_to_table = fn (convert_row,s') =>
    let val len = String.size s'
        fun f ()=
           if !index < len then convert_row() :: f()
           else nil
     in (s := s'; index := 0; f ())
     end
local
  val memo = Array.array(numstates+numrules,ERROR)
  val _ =let fun g i=(Array.update(memo,i,REDUCE(i-numstates)); g(i+1))
       fun f i =
            if i=numstates then g i
            else (Array.update(memo,i,SHIFT (STATE i)); f (i+1))
          in f 0 handle Subscript => ()
          end
in
val entry_to_action = fn 0 => ACCEPT | 1 => ERROR | j => Array.sub(memo,(j-2))
end
val gotoT=Array.fromList(string_to_table(string_to_pairlist(NT,STATE),gotoT))
val actionRows=string_to_table(string_to_pairlist_default(T,entry_to_action),actionRows)
val actionRowNumbers = string_to_list actionRowNumbers
val actionT = let val actionRowLookUp=
let val a=Array.fromList(actionRows) in fn i=>Array.sub(a,i) end
in Array.fromList(map actionRowLookUp actionRowNumbers)
end
in LrTable.mkLrTable {actions=actionT,gotos=gotoT,numRules=numrules,
numStates=numstates,initialState=STATE 0}
end
end
local open Header in
type pos = int
type arg = parserarg
structure MlyValue = 
struct
datatype svalue = VOID | ntVOID of unit ->  unit
 | STRING of unit ->  (string) | REAL of unit ->  (real)
 | INT of unit ->  (int) | QUID of unit ->  (string)
 | UCID of unit ->  (string) | LCID of unit ->  (string)
 | kd of unit ->  (akind) | tpatom of unit ->  (atypeatom)
 | tpseq of unit ->  (atypeseq) | tp of unit ->  (atype)
 | id' of unit ->  (id) | id of unit ->  (id)
 | idlist of unit ->  (string list) | lcid of unit ->  (string)
 | atom of unit ->  (aatom) | termseq of unit ->  (atermseq)
 | term of unit ->  (aterm) | sign of unit ->  (sign_decl)
 | fixdecl of unit ->  (fixity*string list)
 | stringlist of unit ->  (string list)
 | valuelist of unit ->  (switch list) | value of unit ->  (switch)
 | modlist of unit ->  (string list) | module of unit ->  (string)
 | lpdecl of unit ->  (lp_decl) | moddecl of unit ->  (module_decl)
 | scriptdecl of unit ->  (script_decl) | start of unit ->  (result)
end
type svalue = MlyValue.svalue
type result = result
end
structure EC=
struct
open LrTable
val is_keyword =
fn (T 33) => true | (T 35) => true | (T 34) => true | (T 36) => true
 | (T 37) => true | _ => false
val preferred_change = 
nil
val noShift = 
fn (T 0) => true | (T 1) => true | _ => false
val showTerminal =
fn (T 0) => "EOF"
  | (T 1) => "DOT"
  | (T 2) => "LPAREN"
  | (T 3) => "RPAREN"
  | (T 4) => "SEMICOLON"
  | (T 5) => "COMMA"
  | (T 6) => "ARROW"
  | (T 7) => "BACKSLASH"
  | (T 8) => "COLON"
  | (T 9) => "ANONYMOUS"
  | (T 10) => "TERM"
  | (T 11) => "TP"
  | (T 12) => "MODULE"
  | (T 13) => "IMPORT"
  | (T 14) => "ACCUMULATE"
  | (T 15) => "TYPE"
  | (T 16) => "LOCAL"
  | (T 17) => "KIND"
  | (T 18) => "LOCALKIND"
  | (T 19) => "INTTYPE"
  | (T 20) => "STRINGTYPE"
  | (T 21) => "REALTYPE"
  | (T 22) => "INSTREAMTYPE"
  | (T 23) => "OUTSTREAMTYPE"
  | (T 24) => "LCID"
  | (T 25) => "UCID"
  | (T 26) => "QUID"
  | (T 27) => "INT"
  | (T 28) => "REAL"
  | (T 29) => "STRING"
  | (T 30) => "INFIX"
  | (T 31) => "INFIXL"
  | (T 32) => "INFIXR"
  | (T 33) => "LOAD"
  | (T 34) => "QUERY"
  | (T 35) => "SET"
  | (T 36) => "HELP"
  | (T 37) => "SHOW"
  | (T 38) => "BEGIN"
  | (T 39) => "END"
  | (T 40) => "PRINT"
  | (T 41) => "QUIT"
  | _ => "bogus-term"
local open Header in
val errtermvalue=
fn _ => MlyValue.VOID
end
val terms = (T 0) :: (T 1) :: (T 2) :: (T 3) :: (T 4) :: (T 5) :: (T 6
) :: (T 7) :: (T 8) :: (T 9) :: (T 10) :: (T 11) :: (T 12) :: (T 13)
 :: (T 14) :: (T 15) :: (T 16) :: (T 17) :: (T 18) :: (T 19) :: (T 20)
 :: (T 21) :: (T 22) :: (T 23) :: (T 30) :: (T 31) :: (T 32) :: (T 33)
 :: (T 34) :: (T 35) :: (T 36) :: (T 37) :: (T 38) :: (T 39) :: (T 40)
 :: (T 41) :: nil
end
structure Actions =
struct 
exception mlyAction of int
local open Header in
val actions = 
fn (i392,defaultPos,stack,
    (arg):arg) =>
case (i392,stack)
of (0,(_,(MlyValue.scriptdecl scriptdecl1,scriptdeclleft as 
scriptdecl1left,scriptdeclright as scriptdecl1right))::rest671) => 
let val result=MlyValue.start(fn _ => let val scriptdecl as 
scriptdecl1=scriptdecl1 ()
 in (
PR (ParsedScript scriptdecl,
				     loc arg (scriptdeclleft,scriptdeclright))
) end
)
 in (LrTable.NT 0,(result,scriptdecl1left,scriptdecl1right),rest671)
 end
| (1,(_,(MlyValue.moddecl moddecl1,moddeclleft as moddecl1left,
moddeclright as moddecl1right))::rest671) => let val result=
MlyValue.start(fn _ => let val moddecl as moddecl1=moddecl1 ()
 in (
PR (ParsedModule moddecl,
				     loc arg (moddeclleft, moddeclright))
) end
)
 in (LrTable.NT 0,(result,moddecl1left,moddecl1right),rest671) end
| (2,(_,(MlyValue.lpdecl lpdecl1,lpdeclleft as lpdecl1left,lpdeclright
 as lpdecl1right))::rest671) => let val result=MlyValue.start(fn _ => 
let val lpdecl as lpdecl1=lpdecl1 ()
 in (PR (ParsedLp lpdecl,
				     loc arg (lpdeclleft, lpdeclright)))
 end
)
 in (LrTable.NT 0,(result,lpdecl1left,lpdecl1right),rest671) end
| (3,(_,(MlyValue.stringlist stringlist1,_,stringlist1right))::(_,(_,
LOAD1left,_))::rest671) => let val result=MlyValue.scriptdecl(fn _ => 
let val stringlist as stringlist1=stringlist1 ()
 in (Load stringlist) end
)
 in (LrTable.NT 1,(result,LOAD1left,stringlist1right),rest671) end
| (4,(_,(MlyValue.LCID LCID1,_,LCID1right))::(_,(_,SHOW1left,_))::
rest671) => let val result=MlyValue.scriptdecl(fn _ => let val LCID
 as LCID1=LCID1 ()
 in (Show (SOME LCID)) end
)
 in (LrTable.NT 1,(result,SHOW1left,LCID1right),rest671) end
| (5,(_,(_,SHOW1left,SHOW1right))::rest671) => let val result=
MlyValue.scriptdecl(fn _ => (Show NONE))
 in (LrTable.NT 1,(result,SHOW1left,SHOW1right),rest671) end
| (6,(_,(MlyValue.LCID LCID1,_,LCID1right))::(_,(_,HELP1left,_))::
rest671) => let val result=MlyValue.scriptdecl(fn _ => let val LCID
 as LCID1=LCID1 ()
 in (Help (SOME LCID)) end
)
 in (LrTable.NT 1,(result,HELP1left,LCID1right),rest671) end
| (7,(_,(_,HELP1left,HELP1right))::rest671) => let val result=
MlyValue.scriptdecl(fn _ => (Help NONE))
 in (LrTable.NT 1,(result,HELP1left,HELP1right),rest671) end
| (8,(_,(MlyValue.valuelist valuelist1,_,valuelist1right))::(_,(
MlyValue.LCID LCID1,_,_))::(_,(_,SET1left,_))::rest671) => let val 
result=MlyValue.scriptdecl(fn _ => let val LCID as LCID1=LCID1 ()
val valuelist as valuelist1=valuelist1 ()
 in (Set (LCID, valuelist)) end
)
 in (LrTable.NT 1,(result,SET1left,valuelist1right),rest671) end
| (9,(_,(MlyValue.term term1,_,term1right))::(_,(MlyValue.modlist 
modlist1,_,_))::(_,(_,QUERY1left,_))::rest671) => let val result=
MlyValue.scriptdecl(fn _ => let val modlist as modlist1=modlist1 ()
val term as term1=term1 ()
 in (Query (SOME (modlist, SOME term))) end
)
 in (LrTable.NT 1,(result,QUERY1left,term1right),rest671) end
| (10,(_,(MlyValue.modlist modlist1,_,modlist1right))::(_,(_,
QUERY1left,_))::rest671) => let val result=MlyValue.scriptdecl(fn _
 => let val modlist as modlist1=modlist1 ()
 in (Query (SOME (modlist, NONE))) end
)
 in (LrTable.NT 1,(result,QUERY1left,modlist1right),rest671) end
| (11,(_,(_,QUERY1left,QUERY1right))::rest671) => let val result=
MlyValue.scriptdecl(fn _ => (Query NONE))
 in (LrTable.NT 1,(result,QUERY1left,QUERY1right),rest671) end
| (12,(_,(_,BEGIN1left,BEGIN1right))::rest671) => let val result=
MlyValue.scriptdecl(fn _ => (Begin))
 in (LrTable.NT 1,(result,BEGIN1left,BEGIN1right),rest671) end
| (13,(_,(_,END1left,END1right))::rest671) => let val result=
MlyValue.scriptdecl(fn _ => (End))
 in (LrTable.NT 1,(result,END1left,END1right),rest671) end
| (14,(_,(MlyValue.module module1,_,module1right))::(_,(_,PRINT1left,_
))::rest671) => let val result=MlyValue.scriptdecl(fn _ => let val 
module as module1=module1 ()
 in (Print module) end
)
 in (LrTable.NT 1,(result,PRINT1left,module1right),rest671) end
| (15,(_,(_,QUIT1left,QUIT1right))::rest671) => let val result=
MlyValue.scriptdecl(fn _ => (Quit))
 in (LrTable.NT 1,(result,QUIT1left,QUIT1right),rest671) end
| (16,(_,(MlyValue.INT INT1,INT1left,INT1right))::rest671) => let val 
result=MlyValue.value(fn _ => let val INT as INT1=INT1 ()
 in (Val (Lib.Convert.itoa INT)) end
)
 in (LrTable.NT 6,(result,INT1left,INT1right),rest671) end
| (17,(_,(MlyValue.lcid lcid1,lcid1left,lcid1right))::rest671) => let 
val result=MlyValue.value(fn _ => let val lcid as lcid1=lcid1 ()
 in (Var lcid) end
)
 in (LrTable.NT 6,(result,lcid1left,lcid1right),rest671) end
| (18,(_,(MlyValue.STRING STRING1,STRING1left,STRING1right))::rest671)
 => let val result=MlyValue.value(fn _ => let val STRING as STRING1=
STRING1 ()
 in (Val STRING) end
)
 in (LrTable.NT 6,(result,STRING1left,STRING1right),rest671) end
| (19,rest671) => let val result=MlyValue.valuelist(fn _ => ([]))
 in (LrTable.NT 7,(result,defaultPos,defaultPos),rest671) end
| (20,(_,(MlyValue.valuelist valuelist1,_,valuelist1right))::(_,(
MlyValue.value value1,value1left,_))::rest671) => let val result=
MlyValue.valuelist(fn _ => let val value as value1=value1 ()
val valuelist as valuelist1=valuelist1 ()
 in (value :: valuelist) end
)
 in (LrTable.NT 7,(result,value1left,valuelist1right),rest671) end
| (21,(_,(MlyValue.STRING STRING1,STRING1left,STRING1right))::rest671)
 => let val result=MlyValue.stringlist(fn _ => let val STRING as 
STRING1=STRING1 ()
 in ([STRING]) end
)
 in (LrTable.NT 8,(result,STRING1left,STRING1right),rest671) end
| (22,(_,(MlyValue.stringlist stringlist1,_,stringlist1right))::_::(_,
(MlyValue.STRING STRING1,STRING1left,_))::rest671) => let val result=
MlyValue.stringlist(fn _ => let val STRING as STRING1=STRING1 ()
val stringlist as stringlist1=stringlist1 ()
 in (STRING :: stringlist) end
)
 in (LrTable.NT 8,(result,STRING1left,stringlist1right),rest671) end
| (23,(_,(MlyValue.module module1,_,module1right))::(_,(_,MODULE1left,
_))::rest671) => let val result=MlyValue.moddecl(fn _ => let val 
module as module1=module1 ()
 in (Module module) end
)
 in (LrTable.NT 2,(result,MODULE1left,module1right),rest671) end
| (24,(_,(MlyValue.modlist modlist1,_,modlist1right))::(_,(_,
IMPORT1left,_))::rest671) => let val result=MlyValue.moddecl(fn _ => 
let val modlist as modlist1=modlist1 ()
 in (Preamble (Import modlist)) end
)
 in (LrTable.NT 2,(result,IMPORT1left,modlist1right),rest671) end
| (25,(_,(MlyValue.modlist modlist1,_,modlist1right))::(_,(_,
ACCUMULATE1left,_))::rest671) => let val result=MlyValue.moddecl(fn _
 => let val modlist as modlist1=modlist1 ()
 in (Preamble (Accumulate modlist)) end
)
 in (LrTable.NT 2,(result,ACCUMULATE1left,modlist1right),rest671) end
| (26,(_,(MlyValue.UCID UCID1,UCID1left,UCID1right))::rest671) => let 
val result=MlyValue.module(fn _ => let val UCID as UCID1=UCID1 ()
 in (UCID) end
)
 in (LrTable.NT 4,(result,UCID1left,UCID1right),rest671) end
| (27,(_,(MlyValue.LCID LCID1,LCID1left,LCID1right))::rest671) => let 
val result=MlyValue.module(fn _ => let val LCID as LCID1=LCID1 ()
 in (LCID) end
)
 in (LrTable.NT 4,(result,LCID1left,LCID1right),rest671) end
| (28,(_,(MlyValue.module module1,module1left,module1right))::rest671)
 => let val result=MlyValue.modlist(fn _ => let val module as module1=
module1 ()
 in (module :: nil) end
)
 in (LrTable.NT 5,(result,module1left,module1right),rest671) end
| (29,(_,(MlyValue.modlist modlist1,_,modlist1right))::_::(_,(
MlyValue.module module1,module1left,_))::rest671) => let val result=
MlyValue.modlist(fn _ => let val module as module1=module1 ()
val modlist as modlist1=modlist1 ()
 in (module :: modlist) end
)
 in (LrTable.NT 5,(result,module1left,modlist1right),rest671) end
| (30,(_,(MlyValue.sign sign1,sign1left,sign1right))::rest671) => let 
val result=MlyValue.lpdecl(fn _ => let val sign as sign1=sign1 ()
 in (Sign sign) end
)
 in (LrTable.NT 3,(result,sign1left,sign1right),rest671) end
| (31,(_,(MlyValue.term term1,term1left,term1right))::rest671) => let 
val result=MlyValue.lpdecl(fn _ => let val term as term1=term1 ()
 in (Term term) end
)
 in (LrTable.NT 3,(result,term1left,term1right),rest671) end
| (32,(_,(MlyValue.tp tp1,_,tp1right))::(_,(MlyValue.idlist idlist1,_,
_))::(_,(_,TYPE1left,_))::rest671) => let val result=MlyValue.sign(fn 
_ => let val idlist as idlist1=idlist1 ()
val tp as tp1=tp1 ()
 in (Tp (tp, idlist)) end
)
 in (LrTable.NT 10,(result,TYPE1left,tp1right),rest671) end
| (33,(_,(MlyValue.tp tp1,_,tp1right))::(_,(MlyValue.idlist idlist1,_,
_))::(_,(_,LOCAL1left,_))::rest671) => let val result=MlyValue.sign(
fn _ => let val idlist as idlist1=idlist1 ()
val tp as tp1=tp1 ()
 in (Ll (tp, idlist)) end
)
 in (LrTable.NT 10,(result,LOCAL1left,tp1right),rest671) end
| (34,(_,(MlyValue.kd kd1,_,kd1right))::(_,(MlyValue.idlist idlist1,_,
_))::(_,(_,KIND1left,_))::rest671) => let val result=MlyValue.sign(fn 
_ => let val idlist as idlist1=idlist1 ()
val kd as kd1=kd1 ()
 in (Kd (kd, idlist)) end
)
 in (LrTable.NT 10,(result,KIND1left,kd1right),rest671) end
| (35,(_,(MlyValue.kd kd1,_,kd1right))::(_,(MlyValue.idlist idlist1,_,
_))::(_,(_,LOCALKIND1left,_))::rest671) => let val result=
MlyValue.sign(fn _ => let val idlist as idlist1=idlist1 ()
val kd as kd1=kd1 ()
 in (Lk (kd, idlist)) end
)
 in (LrTable.NT 10,(result,LOCALKIND1left,kd1right),rest671) end
| (36,(_,(MlyValue.fixdecl fixdecl1,fixdecl1left,fixdecl1right))::
rest671) => let val result=MlyValue.sign(fn _ => let val fixdecl as 
fixdecl1=fixdecl1 ()
 in (Fx fixdecl) end
)
 in (LrTable.NT 10,(result,fixdecl1left,fixdecl1right),rest671) end
| (37,(_,(MlyValue.INT INT1,_,INTright as INT1right))::(_,(
MlyValue.idlist idlist1,_,_))::(_,(_,INFIXLleft as INFIXL1left,_))::
rest671) => let val result=MlyValue.fixdecl(fn _ => let val idlist as 
idlist1=idlist1 ()
val INT as INT1=INT1 ()
 in (
Infix
				 (check (loc arg (INFIXLleft, INTright), INT),
				 Left),
				 idlist
) end
)
 in (LrTable.NT 9,(result,INFIXL1left,INT1right),rest671) end
| (38,(_,(MlyValue.INT INT1,_,INTright as INT1right))::(_,(
MlyValue.idlist idlist1,_,_))::(_,(_,INFIXRleft as INFIXR1left,_))::
rest671) => let val result=MlyValue.fixdecl(fn _ => let val idlist as 
idlist1=idlist1 ()
val INT as INT1=INT1 ()
 in (
Infix
				 (check (loc arg (INFIXRleft, INTright), INT),
				  Right),
				 idlist
) end
)
 in (LrTable.NT 9,(result,INFIXR1left,INT1right),rest671) end
| (39,(_,(MlyValue.INT INT1,_,INTright as INT1right))::(_,(
MlyValue.idlist idlist1,_,_))::(_,(_,INFIXleft as INFIX1left,_))::
rest671) => let val result=MlyValue.fixdecl(fn _ => let val idlist as 
idlist1=idlist1 ()
val INT as INT1=INT1 ()
 in (
Infix
				 (check (loc arg (INFIXleft, INTright), INT),
				  None),
				 idlist
) end
)
 in (LrTable.NT 9,(result,INFIX1left,INT1right),rest671) end
| (40,(_,(MlyValue.termseq termseq1,termseqleft as termseq1left,
termseqright as termseq1right))::rest671) => let val result=
MlyValue.term(fn _ => let val termseq as termseq1=termseq1 ()
 in (seq_to_term termseq
				 (loc arg (termseqleft, termseqright)))
 end
)
 in (LrTable.NT 11,(result,termseq1left,termseq1right),rest671) end
| (41,(_,(MlyValue.atom atom1,atomleft as atom1left,atomright as 
atom1right))::rest671) => let val result=MlyValue.termseq(fn _ => let 
val atom as atom1=atom1 ()
 in (mk_oneseq atom
				 (loc arg (atomleft, atomright))) end
)
 in (LrTable.NT 12,(result,atom1left,atom1right),rest671) end
| (42,(_,(MlyValue.tp tp1,_,tpright as tp1right))::_::(_,(
MlyValue.atom atom1,atomleft as atom1left,_))::rest671) => let val 
result=MlyValue.termseq(fn _ => let val atom as atom1=atom1 ()
val tp as tp1=tp1 ()
 in (
let
				     val location =
					 loc arg (atomleft, tpright)
				 in
				     mk_oneseq
				     (term_to_atom
				      (mk_hastype
				       (atom_to_term atom, tp)
				       location)) location
				 end
) end
)
 in (LrTable.NT 12,(result,atom1left,tp1right),rest671) end
| (43,(_,(MlyValue.atom atom1,_,atomright as atom1right))::(_,(
MlyValue.termseq termseq1,termseqleft as termseq1left,_))::rest671)
 => let val result=MlyValue.termseq(fn _ => let val termseq as 
termseq1=termseq1 ()
val atom as atom1=atom1 ()
 in (
mk_termseq (termseq, atom)
				 (loc arg (termseqleft, atomright)))
 end
)
 in (LrTable.NT 12,(result,termseq1left,atom1right),rest671) end
| (44,(_,(_,_,RPAREN1right))::(_,(MlyValue.term term1,_,_))::(_,(_,
LPAREN1left,_))::rest671) => let val result=MlyValue.atom(fn _ => let 
val term as term1=term1 ()
 in (term_to_atom term) end
)
 in (LrTable.NT 13,(result,LPAREN1left,RPAREN1right),rest671) end
| (45,(_,(_,COMMAleft as COMMA1left,COMMAright as COMMA1right))::
rest671) => let val result=MlyValue.atom(fn _ => (
mk_const "," (loc arg (COMMAleft,COMMAright))))
 in (LrTable.NT 13,(result,COMMA1left,COMMA1right),rest671) end
| (46,(_,(MlyValue.INT INT1,INTleft as INT1left,INTright as INT1right)
)::rest671) => let val result=MlyValue.atom(fn _ => let val INT as 
INT1=INT1 ()
 in (
term_to_atom
				 (mk_int INT
				  (loc arg (INTleft, INTright))))
 end
)
 in (LrTable.NT 13,(result,INT1left,INT1right),rest671) end
| (47,(_,(MlyValue.REAL REAL1,REALleft as REAL1left,REALright as 
REAL1right))::rest671) => let val result=MlyValue.atom(fn _ => let 
val REAL as REAL1=REAL1 ()
 in (
term_to_atom
				 (mk_real REAL
				  (loc arg (REALleft, REALright)))
) end
)
 in (LrTable.NT 13,(result,REAL1left,REAL1right),rest671) end
| (48,(_,(MlyValue.STRING STRING1,STRINGleft as STRING1left,
STRINGright as STRING1right))::rest671) => let val result=
MlyValue.atom(fn _ => let val STRING as STRING1=STRING1 ()
 in (
term_to_atom
				 (mk_string STRING
				  (loc arg (STRINGleft, STRINGright)))
) end
)
 in (LrTable.NT 13,(result,STRING1left,STRING1right),rest671) end
| (49,(_,(_,ANONYMOUSleft as ANONYMOUS1left,ANONYMOUSright as 
ANONYMOUS1right))::rest671) => let val result=MlyValue.atom(fn _ => (
term_to_atom
				 (mk_wildcard
				  (loc arg(ANONYMOUSleft,ANONYMOUSright)))
))
 in (LrTable.NT 13,(result,ANONYMOUS1left,ANONYMOUS1right),rest671)
 end
| (50,(_,(MlyValue.id id1,idleft as id1left,idright as id1right))::
rest671) => let val result=MlyValue.atom(fn _ => let val id as id1=id1
 ()
 in (id_to_atom id (loc arg (idleft, idright))) end
)
 in (LrTable.NT 13,(result,id1left,id1right),rest671) end
| (51,(_,(MlyValue.QUID QUID1,QUIDleft as QUID1left,QUIDright as 
QUID1right))::rest671) => let val result=MlyValue.atom(fn _ => let 
val QUID as QUID1=QUID1 ()
 in (
term_to_atom
				 (atom_to_term
				  (mk_bv_const QUID
				   (loc arg (QUIDleft, QUIDright))))
) end
)
 in (LrTable.NT 13,(result,QUID1left,QUID1right),rest671) end
| (52,(_,(MlyValue.term term1,_,termright as term1right))::_::(_,(
MlyValue.id id1,idleft as id1left,_))::rest671) => let val result=
MlyValue.atom(fn _ => let val id as id1=id1 ()
val term as term1=term1 ()
 in (
term_to_atom
				 (mk_abst (id, term)
				  (loc arg (idleft, termright)))
) end
)
 in (LrTable.NT 13,(result,id1left,term1right),rest671) end
| (53,(_,(_,_,RPAREN1right))::(_,(MlyValue.id id1,_,_))::(_,(_,
LPAREN1left,_))::rest671) => let val result=MlyValue.id(fn _ => let 
val id as id1=id1 ()
 in (id) end
)
 in (LrTable.NT 16,(result,LPAREN1left,RPAREN1right),rest671) end
| (54,(_,(MlyValue.LCID LCID1,LCIDleft as LCID1left,LCIDright as 
LCID1right))::rest671) => let val result=MlyValue.id(fn _ => let val 
LCID as LCID1=LCID1 ()
 in (mk_lcid LCID (loc arg (LCIDleft, LCIDright))) end
)
 in (LrTable.NT 16,(result,LCID1left,LCID1right),rest671) end
| (55,(_,(MlyValue.UCID UCID1,UCIDleft as UCID1left,UCIDright as 
UCID1right))::rest671) => let val result=MlyValue.id(fn _ => let val 
UCID as UCID1=UCID1 ()
 in (mk_ucid UCID (loc arg (UCIDleft, UCIDright))) end
)
 in (LrTable.NT 16,(result,UCID1left,UCID1right),rest671) end
| (56,(_,(MlyValue.tp tp1,_,tpright as tp1right))::_::(_,(MlyValue.id 
id1,idleft as id1left,_))::rest671) => let val result=MlyValue.id(fn _
 => let val id as id1=id1 ()
val tp as tp1=tp1 ()
 in (mk_of_type (id, tp)
				 (loc arg (idleft, tpright))) end
)
 in (LrTable.NT 16,(result,id1left,tp1right),rest671) end
| (57,(_,(MlyValue.QUID QUID1,QUID1left,QUID1right))::rest671) => let 
val result=MlyValue.lcid(fn _ => let val QUID as QUID1=QUID1 ()
 in (QUID) end
)
 in (LrTable.NT 14,(result,QUID1left,QUID1right),rest671) end
| (58,(_,(MlyValue.LCID LCID1,LCID1left,LCID1right))::rest671) => let 
val result=MlyValue.lcid(fn _ => let val LCID as LCID1=LCID1 ()
 in (LCID) end
)
 in (LrTable.NT 14,(result,LCID1left,LCID1right),rest671) end
| (59,(_,(MlyValue.lcid lcid1,lcid1left,lcid1right))::rest671) => let 
val result=MlyValue.idlist(fn _ => let val lcid as lcid1=lcid1 ()
 in (lcid :: nil) end
)
 in (LrTable.NT 15,(result,lcid1left,lcid1right),rest671) end
| (60,(_,(MlyValue.idlist idlist1,_,idlist1right))::_::(_,(
MlyValue.lcid lcid1,lcid1left,_))::rest671) => let val result=
MlyValue.idlist(fn _ => let val lcid as lcid1=lcid1 ()
val idlist as idlist1=idlist1 ()
 in (lcid :: idlist) end
)
 in (LrTable.NT 15,(result,lcid1left,idlist1right),rest671) end
| (61,(_,(MlyValue.tp tp2,_,tp2right))::_::(_,(MlyValue.tp tp1,tp1left
,_))::rest671) => let val result=MlyValue.tp(fn _ => let val tp1=tp1 
()
val tp2=tp2 ()
 in (mk_arrow (tp1, tp2)
				 (loc arg (tp1left, tp2right))) end
)
 in (LrTable.NT 18,(result,tp1left,tp2right),rest671) end
| (62,(_,(MlyValue.tpseq tpseq1,tpseqleft as tpseq1left,tpseqright as 
tpseq1right))::rest671) => let val result=MlyValue.tp(fn _ => let val 
tpseq as tpseq1=tpseq1 ()
 in (seq_to_type tpseq
				 (loc arg (tpseqleft, tpseqright))) end
)
 in (LrTable.NT 18,(result,tpseq1left,tpseq1right),rest671) end
| (63,(_,(MlyValue.tpatom tpatom1,tpatomleft as tpatom1left,
tpatomright as tpatom1right))::rest671) => let val result=
MlyValue.tpseq(fn _ => let val tpatom as tpatom1=tpatom1 ()
 in (mk_onetypeseq tpatom
				 (loc arg (tpatomleft, tpatomright)))
 end
)
 in (LrTable.NT 19,(result,tpatom1left,tpatom1right),rest671) end
| (64,(_,(MlyValue.tpatom tpatom1,_,tpatomright as tpatom1right))::(_,
(MlyValue.tpseq tpseq1,tpseqleft as tpseq1left,_))::rest671) => let 
val result=MlyValue.tpseq(fn _ => let val tpseq as tpseq1=tpseq1 ()
val tpatom as tpatom1=tpatom1 ()
 in (
mk_typeseq (tpseq, tpatom)
				 (loc arg (tpseqleft, tpatomright)))
 end
)
 in (LrTable.NT 19,(result,tpseq1left,tpatom1right),rest671) end
| (65,(_,(MlyValue.lcid lcid1,lcidleft as lcid1left,lcidright as 
lcid1right))::rest671) => let val result=MlyValue.tpatom(fn _ => let 
val lcid as lcid1=lcid1 ()
 in (
type_to_atom
				 (mk_tconst lcid
				  (loc arg (lcidleft,lcidright)))
) end
)
 in (LrTable.NT 20,(result,lcid1left,lcid1right),rest671) end
| (66,(_,(MlyValue.UCID UCID1,UCIDleft as UCID1left,UCIDright as 
UCID1right))::rest671) => let val result=MlyValue.tpatom(fn _ => let 
val UCID as UCID1=UCID1 ()
 in (type_to_atom
				 (mk_ftv UCID (loc arg(UCIDleft,UCIDright))))
 end
)
 in (LrTable.NT 20,(result,UCID1left,UCID1right),rest671) end
| (67,(_,(_,_,RPAREN1right))::(_,(MlyValue.tp tp1,_,_))::(_,(_,
LPAREN1left,_))::rest671) => let val result=MlyValue.tpatom(fn _ => 
let val tp as tp1=tp1 ()
 in (type_to_atom tp) end
)
 in (LrTable.NT 20,(result,LPAREN1left,RPAREN1right),rest671) end
| (68,(_,(_,INTTYPEleft as INTTYPE1left,INTTYPEright as INTTYPE1right)
)::rest671) => let val result=MlyValue.tpatom(fn _ => (
type_to_atom
				 (mk_int_type
				  (loc arg
				   (INTTYPEleft, INTTYPEright)))
))
 in (LrTable.NT 20,(result,INTTYPE1left,INTTYPE1right),rest671) end
| (69,(_,(_,REALTYPEleft as REALTYPE1left,REALTYPEright as 
REALTYPE1right))::rest671) => let val result=MlyValue.tpatom(fn _ => (
type_to_atom
				 (mk_real_type
				  (loc arg
				   (REALTYPEleft, REALTYPEright)))
))
 in (LrTable.NT 20,(result,REALTYPE1left,REALTYPE1right),rest671) end
| (70,(_,(_,STRINGTYPEleft as STRINGTYPE1left,STRINGTYPEright as 
STRINGTYPE1right))::rest671) => let val result=MlyValue.tpatom(fn _
 => (
type_to_atom
				 (mk_string_type
				  (loc arg 
				   (STRINGTYPEleft, STRINGTYPEright)))
))
 in (LrTable.NT 20,(result,STRINGTYPE1left,STRINGTYPE1right),rest671)
 end
| (71,(_,(_,INSTREAMTYPEleft as INSTREAMTYPE1left,INSTREAMTYPEright
 as INSTREAMTYPE1right))::rest671) => let val result=MlyValue.tpatom(
fn _ => (
type_to_atom
				 (mk_in_stream_type
				  (loc arg
				   (INSTREAMTYPEleft, INSTREAMTYPEright)))
))
 in (LrTable.NT 20,(result,INSTREAMTYPE1left,INSTREAMTYPE1right),
rest671) end
| (72,(_,(_,OUTSTREAMTYPEleft as OUTSTREAMTYPE1left,OUTSTREAMTYPEright
 as OUTSTREAMTYPE1right))::rest671) => let val result=MlyValue.tpatom(
fn _ => (
type_to_atom
				 (mk_out_stream_type
				  (loc arg
				   (OUTSTREAMTYPEleft, OUTSTREAMTYPEright)))
))
 in (LrTable.NT 20,(result,OUTSTREAMTYPE1left,OUTSTREAMTYPE1right),
rest671) end
| (73,(_,(_,TYPEleft as TYPE1left,TYPEright as TYPE1right))::rest671)
 => let val result=MlyValue.kd(fn _ => (
mk_type (loc arg (TYPEleft, TYPEright))))
 in (LrTable.NT 21,(result,TYPE1left,TYPE1right),rest671) end
| (74,(_,(MlyValue.kd kd1,_,kdright as kd1right))::_::(_,(_,TYPEleft
 as TYPE1left,_))::rest671) => let val result=MlyValue.kd(fn _ => let 
val kd as kd1=kd1 ()
 in (mk_karrow kd (loc arg (TYPEleft, kdright))) end
)
 in (LrTable.NT 21,(result,TYPE1left,kd1right),rest671) end
| _ => raise (mlyAction i392)
end
val void = MlyValue.VOID
val extract = fn a => (fn MlyValue.start x => x
| _ => let exception ParseInternal
	in raise ParseInternal end) a ()
end
end
structure Tokens : LP_TOKENS =
struct
type svalue = ParserData.svalue
type ('a,'b) token = ('a,'b) Token.token
fun EOF (p1,p2) = Token.TOKEN (ParserData.LrTable.T 0,(
ParserData.MlyValue.VOID,p1,p2))
fun DOT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 1,(
ParserData.MlyValue.VOID,p1,p2))
fun LPAREN (p1,p2) = Token.TOKEN (ParserData.LrTable.T 2,(
ParserData.MlyValue.VOID,p1,p2))
fun RPAREN (p1,p2) = Token.TOKEN (ParserData.LrTable.T 3,(
ParserData.MlyValue.VOID,p1,p2))
fun SEMICOLON (p1,p2) = Token.TOKEN (ParserData.LrTable.T 4,(
ParserData.MlyValue.VOID,p1,p2))
fun COMMA (p1,p2) = Token.TOKEN (ParserData.LrTable.T 5,(
ParserData.MlyValue.VOID,p1,p2))
fun ARROW (p1,p2) = Token.TOKEN (ParserData.LrTable.T 6,(
ParserData.MlyValue.VOID,p1,p2))
fun BACKSLASH (p1,p2) = Token.TOKEN (ParserData.LrTable.T 7,(
ParserData.MlyValue.VOID,p1,p2))
fun COLON (p1,p2) = Token.TOKEN (ParserData.LrTable.T 8,(
ParserData.MlyValue.VOID,p1,p2))
fun ANONYMOUS (p1,p2) = Token.TOKEN (ParserData.LrTable.T 9,(
ParserData.MlyValue.VOID,p1,p2))
fun TERM (p1,p2) = Token.TOKEN (ParserData.LrTable.T 10,(
ParserData.MlyValue.VOID,p1,p2))
fun TP (p1,p2) = Token.TOKEN (ParserData.LrTable.T 11,(
ParserData.MlyValue.VOID,p1,p2))
fun MODULE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 12,(
ParserData.MlyValue.VOID,p1,p2))
fun IMPORT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 13,(
ParserData.MlyValue.VOID,p1,p2))
fun ACCUMULATE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 14,(
ParserData.MlyValue.VOID,p1,p2))
fun TYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 15,(
ParserData.MlyValue.VOID,p1,p2))
fun LOCAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 16,(
ParserData.MlyValue.VOID,p1,p2))
fun KIND (p1,p2) = Token.TOKEN (ParserData.LrTable.T 17,(
ParserData.MlyValue.VOID,p1,p2))
fun LOCALKIND (p1,p2) = Token.TOKEN (ParserData.LrTable.T 18,(
ParserData.MlyValue.VOID,p1,p2))
fun INTTYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 19,(
ParserData.MlyValue.VOID,p1,p2))
fun STRINGTYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 20,(
ParserData.MlyValue.VOID,p1,p2))
fun REALTYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 21,(
ParserData.MlyValue.VOID,p1,p2))
fun INSTREAMTYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 22,(
ParserData.MlyValue.VOID,p1,p2))
fun OUTSTREAMTYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 23,(
ParserData.MlyValue.VOID,p1,p2))
fun LCID (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 24,(
ParserData.MlyValue.LCID (fn () => i),p1,p2))
fun UCID (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 25,(
ParserData.MlyValue.UCID (fn () => i),p1,p2))
fun QUID (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 26,(
ParserData.MlyValue.QUID (fn () => i),p1,p2))
fun INT (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 27,(
ParserData.MlyValue.INT (fn () => i),p1,p2))
fun REAL (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 28,(
ParserData.MlyValue.REAL (fn () => i),p1,p2))
fun STRING (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 29,(
ParserData.MlyValue.STRING (fn () => i),p1,p2))
fun INFIX (p1,p2) = Token.TOKEN (ParserData.LrTable.T 30,(
ParserData.MlyValue.VOID,p1,p2))
fun INFIXL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 31,(
ParserData.MlyValue.VOID,p1,p2))
fun INFIXR (p1,p2) = Token.TOKEN (ParserData.LrTable.T 32,(
ParserData.MlyValue.VOID,p1,p2))
fun LOAD (p1,p2) = Token.TOKEN (ParserData.LrTable.T 33,(
ParserData.MlyValue.VOID,p1,p2))
fun QUERY (p1,p2) = Token.TOKEN (ParserData.LrTable.T 34,(
ParserData.MlyValue.VOID,p1,p2))
fun SET (p1,p2) = Token.TOKEN (ParserData.LrTable.T 35,(
ParserData.MlyValue.VOID,p1,p2))
fun HELP (p1,p2) = Token.TOKEN (ParserData.LrTable.T 36,(
ParserData.MlyValue.VOID,p1,p2))
fun SHOW (p1,p2) = Token.TOKEN (ParserData.LrTable.T 37,(
ParserData.MlyValue.VOID,p1,p2))
fun BEGIN (p1,p2) = Token.TOKEN (ParserData.LrTable.T 38,(
ParserData.MlyValue.VOID,p1,p2))
fun END (p1,p2) = Token.TOKEN (ParserData.LrTable.T 39,(
ParserData.MlyValue.VOID,p1,p2))
fun PRINT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 40,(
ParserData.MlyValue.VOID,p1,p2))
fun QUIT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 41,(
ParserData.MlyValue.VOID,p1,p2))
end
end
