(* parse.sig - Parser primitives					*)

(* Copyright (c) 1991,1994,1995 by Carnegie Mellon University		*)
(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Authors:								*)
(*	Frank Pfenning <fp@cs.cmu.edu>					*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

signature PARSE =
sig

    structure Parser : ARG_PARSER;

    type location;
    type parse_result;

    type parse_stream;

    val interactive_stream_init : Lib.IO.instream -> string -> parse_stream;
    val stream_init : Lib.IO.instream -> string -> parse_stream;
    val file_init : string -> (unit -> unit) * parse_stream;

    val stream_name : parse_stream -> string;
    val reinit_stream : parse_stream -> parse_stream;

    val parse : string * string -> parse_stream ->
	(parse_result * location) option;

    val unparse : parse_stream -> (parse_result * location) option -> unit;

    val is_interactive : parse_stream -> bool;

end  (* signature PARSE *)
