(* parser_interface.fun - interface to the ml-yacc generated parser	*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

functor ParserInterface
    (structure Absyn : ABSYN
     structure Fixity : FIXITY)
	 : PARSER_INTERFACE =
struct

    open Fixity Absyn;

    datatype parse_result =
	ParsedScript of script_decl
      | ParsedModule of module_decl
      | ParsedLp of lp_decl
	
    and script_decl =
	Load of string list
      | Set of string * (switch list)
      | Show of string option
      | Help of string option
      | Query of (string list * aterm option) option
      | Quit
      | Begin
      | End
      | Print of string

    and switch =
	Var of string
      | Val of string
	
    and module_decl =
	Module of string
      | Preamble of inc

    and inc =
	Import of string list
      | Accumulate of string list
	
    and lp_decl =
	Sign of sign_decl
      | Term of aterm

    and sign_decl =
	Tp of atype * string list
      | Kd of akind * string list
      | Ll of atype * string list
      | Lk of akind * string list
      | Fx of fixity * string list;

    datatype result =
	PR of parse_result * location;

end; (* ParserInterface *)
