(* table.sig - a simple polymorphic table signature			*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

signature TABLE =
    sig

	type ('a, 'b) table;
	    
	val mk_table : (('a -> int) * ('a * 'a -> bool)) ->('a, 'b) table;
	val insert : ('a, 'b) table -> ('a * 'b) -> unit;
	val find : ('a, 'b) table -> 'a -> 'b option;
	val remove : ('a, 'b) table -> 'a -> unit;
                                
	val list_items : ('a, 'b) table -> ('a * 'b) list;

	(* Map yields a new table, leaving the old table in tact. *)
	val map : ('a * 'b -> 'c) -> ('a, 'b) table -> ('a, 'c) table;
(*
	val copy : ('a, 'b) table -> ('a, 'b) table;
	    *)
    end;  (* signature TABLE *)

