(* table_hash.fun - interface to NJ/SML lib hash tables.		*)

(* Copyright (c) 1995,1996 by the University of Pennsylvania		*)

(* For information about the distributaion, copying, and modification	*)
(* of this software, please read the file COPYING located in the root	*)
(* directory of this distribnutaion. If you did not receive the file	*)
(* COPYING write to Philip Wickline at the address below.		*)

(* This program is distributed in the hope that it will be useful but	*)
(* WITHOUT ANY WARRANTY; without even the implied warranty of		*)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	*)
(* COPYING for more details.						*)

(* For information about the structure of the Terzo lambdaProlog	*)
(* implementation, see the file src/README in this distribution. Please	*)
(* address any questions about this code or the Terzo lambdaProlog	*)
(* implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	*)

(* Author:								*)
(*	Philip Wickline <philipw@saul.cis.upenn.edu>			*)

functor TableHash () : TABLE =
    struct

	(* The functor on the rhs is intended to be the 
	 * HashTable functor from the njsml library v0.3. *)
	structure Hash : HASH_TABLE = HashTable;

	type key_val = Word.word;
	type ('a, 'b) table = ('a, 'b) Hash.hash_table;

	exception NotFound;

	fun mk_table (key, eq) =
	    Hash.mkTable (key, eq) (32, NotFound);

	val insert = Hash.insert;

	val find = Hash.find;

	fun remove tab key = (Hash.remove tab key; ()) 
	    handle NotFound => ();

	val list_items = Hash.listItemsi;

	val map = Hash.mapi;
	val copy = Hash.copy;

    end; (* functor HashTable *)
